#include "FilePromptUtil.h"

//WINDOWS VERSION
#include "Windows.h"

using namespace std;

#pragma(lib, "comdlg32.lib");

//internal utility function, attempts to find main GUI window of application using calling thread.
HWND GetMainWindow()
{
	GUITHREADINFO info;
	info.cbSize = sizeof(GUITHREADINFO);
	if(!GetGUIThreadInfo(NULL, &info))
		return 0;

	return info.hwndActive;
}

string FilePromptUtil::SaveFileName()
{
	char filename[1024];
	memset(filename, 0, sizeof(filename));

	OPENFILENAMEA Ofn;
	Ofn.lStructSize = sizeof(OPENFILENAMEA);
	Ofn.hwndOwner = GetMainWindow();
	Ofn.lpstrFilter = "XML Files (*.xml)\0*.xml\0All Files\0*.*\0\0";
	Ofn.lpstrFile= filename;
	Ofn.nMaxFile = sizeof(filename) / sizeof(*filename); 
	Ofn.lpstrFileTitle = NULL;
	Ofn.lpstrCustomFilter = NULL;
	Ofn.lpstrInitialDir = (LPSTR)NULL; 
	Ofn.Flags = OFN_OVERWRITEPROMPT; 
	Ofn.lpstrTitle = "ARIGHT";
	Ofn.lpstrDefExt = NULL;
	Ofn.hInstance = NULL;

	GetSaveFileNameA(&Ofn);
	return string(filename);
}

string FilePromptUtil::LoadFileName()
{
	char filename[1024];
	memset(filename, 0, sizeof(filename));

	OPENFILENAMEA Ofn;
	Ofn.lStructSize = sizeof(OPENFILENAMEA);
	Ofn.hwndOwner = GetMainWindow();
	Ofn.lpstrFilter = "XML Files (*.xml)\0*.xml\0All Files\0*.*\0\0";
	Ofn.lpstrFile= filename;
	Ofn.nMaxFile = sizeof(filename) / sizeof(*filename); 
	Ofn.lpstrFileTitle = NULL;
	Ofn.lpstrCustomFilter = NULL;
	Ofn.lpstrInitialDir = (LPSTR)NULL; 
	Ofn.Flags = OFN_OVERWRITEPROMPT; 
	Ofn.lpstrTitle = "ARIGHT";
	Ofn.lpstrDefExt = NULL;
	Ofn.hInstance = NULL;

	GetOpenFileNameA(&Ofn);
	return string(filename);
}


FilePromptUtil::FilePromptUtil(void)
{
}

FilePromptUtil::~FilePromptUtil(void)
{
}