#import "FilePromptUtil.h"
#import <Cocoa/Cocoa.h>

static string gEmptyString("");
static NSArray* gAllowedFileTypes = [NSArray arrayWithObject: @"xml"];

static string stringFromNSString(NSString* aString);

string FilePromptUtil::SaveFileName()
{
    NSSavePanel* panel = [NSSavePanel savePanel];
    [panel setTitle: @"Select XML file to save to"];
    [panel setAllowedFileTypes: gAllowedFileTypes];
    [panel setCanCreateDirectories: YES];
    [panel setCanSelectHiddenExtension: YES];
    int ret = [panel runModal];
    return (ret==NSFileHandlingPanelOKButton ? stringFromNSString([panel filename]) : gEmptyString);
}

string FilePromptUtil::LoadFileName()
{
    NSOpenPanel* panel = [NSOpenPanel openPanel];
    [panel setTitle: @"Select XML file to load from"];
    [panel setCanChooseDirectories: NO];
    int ret = [panel runModalForTypes: gAllowedFileTypes];
    return (ret==NSFileHandlingPanelOKButton ? stringFromNSString([panel filename]) : gEmptyString);
}

static string stringFromNSString(NSString* aString)
{
    return std::string([aString UTF8String]);
}
