#include "Vector3d.h"
#include <math.h>

Vector3d::Vector3d(void)
{
	x = y = z = 0.0f;
}

Vector3d::Vector3d(float newX, float newY, float newZ)
{
	Initialize(newX, newY, newZ);
}

Vector3d::Vector3d(Vector3d const& source)
{
	Initialize(source.x, source.y, source.z);
}

void Vector3d::Initialize(float newX, float newY, float newZ)
{
	x = newX;
	y = newY;
	z = newZ;
}

Vector3d::~Vector3d(void)
{
}

float Vector3d::Dot(Vector3d param)
{
	return (x * param.x + y * param.y + z * param.z);
}

float Vector3d::Magnitude()
{
	//pythagorean theorem FTW
	return(sqrt(x*x + y*y + z*z));
}

Vector3d Vector3d::Normalize()
{
	float mag = Magnitude();
	if(mag == 0)
		return Vector3d(0,0,0);

	return Vector3d(x/mag, y/mag, z/mag);
}

Vector3d Vector3d::operator -(Vector3d const& source)
{
	return Vector3d(x - source.x, y - source.y, z - source.z);
}

Vector3d Vector3d::operator +(Vector3d const& source)
{
	return Vector3d(x + source.x, y + source.y, z + source.z);
}

Vector3d Vector3d::operator *(float amount)
{
	return Vector3d(x * amount, y * amount, z * amount);
}